/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables;


import be.lghs.accounting.model.Accounting;
import be.lghs.accounting.model.Keys;
import be.lghs.accounting.model.tables.records.MovementTagsRecord;

import java.util.Arrays;
import java.util.List;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Check;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Name;
import org.jooq.Record;
import org.jooq.Row2;
import org.jooq.Schema;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.Internal;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MovementTags extends TableImpl<MovementTagsRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>accounting.movement_tags</code>
     */
    public static final MovementTags MOVEMENT_TAGS = new MovementTags();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<MovementTagsRecord> getRecordType() {
        return MovementTagsRecord.class;
    }

    /**
     * The column <code>accounting.movement_tags.movement_id</code>.
     */
    public final TableField<MovementTagsRecord, UUID> MOVEMENT_ID = createField(DSL.name("movement_id"), SQLDataType.UUID.nullable(false), this, "");

    /**
     * The column <code>accounting.movement_tags.content</code>.
     */
    public final TableField<MovementTagsRecord, String> CONTENT = createField(DSL.name("content"), SQLDataType.VARCHAR(30).nullable(false), this, "");

    private MovementTags(Name alias, Table<MovementTagsRecord> aliased) {
        this(alias, aliased, null);
    }

    private MovementTags(Name alias, Table<MovementTagsRecord> aliased, Field<?>[] parameters) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table());
    }

    /**
     * Create an aliased <code>accounting.movement_tags</code> table reference
     */
    public MovementTags(String alias) {
        this(DSL.name(alias), MOVEMENT_TAGS);
    }

    /**
     * Create an aliased <code>accounting.movement_tags</code> table reference
     */
    public MovementTags(Name alias) {
        this(alias, MOVEMENT_TAGS);
    }

    /**
     * Create a <code>accounting.movement_tags</code> table reference
     */
    public MovementTags() {
        this(DSL.name("movement_tags"), null);
    }

    public <O extends Record> MovementTags(Table<O> child, ForeignKey<O, MovementTagsRecord> key) {
        super(child, key, MOVEMENT_TAGS);
    }

    @Override
    public Schema getSchema() {
        return Accounting.ACCOUNTING;
    }

    @Override
    public UniqueKey<MovementTagsRecord> getPrimaryKey() {
        return Keys.MOVEMENT_TAGS_PKEY;
    }

    @Override
    public List<UniqueKey<MovementTagsRecord>> getKeys() {
        return Arrays.<UniqueKey<MovementTagsRecord>>asList(Keys.MOVEMENT_TAGS_PKEY);
    }

    @Override
    public List<ForeignKey<MovementTagsRecord, ?>> getReferences() {
        return Arrays.<ForeignKey<MovementTagsRecord, ?>>asList(Keys.MOVEMENT_TAGS__MOVEMENT_TAGS_MOVEMENT_ID_FKEY);
    }

    private transient Movements _movements;

    public Movements movements() {
        if (_movements == null)
            _movements = new Movements(this, Keys.MOVEMENT_TAGS__MOVEMENT_TAGS_MOVEMENT_ID_FKEY);

        return _movements;
    }

    @Override
    public List<Check<MovementTagsRecord>> getChecks() {
        return Arrays.<Check<MovementTagsRecord>>asList(
              Internal.createCheck(this, DSL.name("movement_tags_content_check"), "(((content)::text = btrim((content)::text, ' '::text)))", true)
        );
    }

    @Override
    public MovementTags as(String alias) {
        return new MovementTags(DSL.name(alias), this);
    }

    @Override
    public MovementTags as(Name alias) {
        return new MovementTags(alias, this);
    }

    /**
     * Rename this table
     */
    @Override
    public MovementTags rename(String name) {
        return new MovementTags(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public MovementTags rename(Name name) {
        return new MovementTags(name, null);
    }

    // -------------------------------------------------------------------------
    // Row2 type methods
    // -------------------------------------------------------------------------

    @Override
    public Row2<UUID, String> fieldsRow() {
        return (Row2) super.fieldsRow();
    }
}
